Summary: GNU Common Lisp compiler
Name: gcl

%global momorel 4
Version: 2.6.7
Release: %{momorel}m
License: LGPL
Group: Development/Languages
URL: http://www.gnu.org/software/gcl/

%NoSource 0 ftp://ftp.gnu.org/pub/gnu/%{name}/%{name}-%{version}.tar.gz c0f42e1f391162e5ac90912a70e8ecc3
Source1: gcl.sh
Patch0: gcl-2.6.6-lib64.patch
Patch1: gcl-pers.patch
Patch2: gcl-bash.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires(build): tcl >= 8.4.5-1m, tk >= 8.4.5-1m, ncurses-devel, readline-devel >= 5.0
BuildRequires(build): gmp-devel, binutils-devel
Requires: gcc

%description
GNU Common Lisp (GCL) is a Common Lisp compiler and interpreter
implemented in C, and complying mostly with the standard set forth in
the book "Common Lisp, the Language I".  It attempts to strike a
useful middle ground in performance and portability from its design
around C.

This package contains the Lisp system itself.  Documentation is
provided in the gcl-doc package.

%prep
%setup -q
%if %{_lib} == "lib64"
%patch0 -p1 -b .lib64~
%endif

%patch1 -p1 -b .pers~
%patch2 -p1 -b .bash~

%build
%ifarch x86_64
%global optflags %(echo %{optflags}|sed 's/-fPIC//'|sed 's/-DPIC//')
%endif

%configure \
  --enable-notify=no \
  --enable-gmp \
  --enable-common-binary \
  --disable-dlopen \
  --enable-statsysbfd \
  --disable-dynsysbfd \
  --disable-locbfd \
  --disable-custreloc \
  --disable-debug \
  --disable-pic \
  --enable-dynsysgmp \
  --with-x \
  --enable-readline \
  --enable-infodir=%{_infodir}
%make

. %{_libdir}/tkConfig.sh
tk_libdir=%{_libdir}/tk${TK_VERSION}
gcl_libdir=%{_libdir}/%{name}-%{version}
%__sed -e "s!@gcl_libdir@!${gcl_libdir}!g" \
       -e "s!@tk_libdir@!${tk_libdir}!g" \
       %{S:1} \
  > gcl.sh

%install
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}
%makeinstall \
  EMACS_SITE_LISP="" \
  INFO_DIR=%{buildroot}%{_infodir}/
# install lsp/gcl_readline.lsp manually, otherwise gcl script does not work (but not sure...)
%__install -m 0755 lsp/gcl_readline.lsp %{buildroot}%{_libdir}/%{name}-%{version}/lsp

%__install -m 0755 gcl.sh %{buildroot}%{_bindir}/gcl

%__rm -rf gcl-doc
%__mkdir gcl-doc
%__mv %{buildroot}%{_datadir}/doc/gcl-* ./gcl-doc/

# remove
%__rm -f %{buildroot}/usr/share/info/dir

# revise permision
#find %{buildroot}%{_datadir} -type f -perm 640 -print0 | xargs -0 chmod 644
#find %{buildroot}%{_datadir} -type f -perm 750 -print0 | xargs -0 chmod 644
find %{buildroot}%{_libdir}/gcl-%{version} -type f -perm 750 -print0 | xargs -0 chmod 755
find %{buildroot}%{_libdir}/gcl-%{version} -type f -perm 640 -print0 | xargs -0 chmod 644
chmod 644 readme faq ChangeLog

%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%files
%defattr(-, root, root)
%doc COPYING* ChangeLog* RELEASE* readme* gcl-doc/* faq
%{_bindir}/gcl
%{_libdir}/gcl-%{version}
%{_infodir}/gcl*

%changelog
* Mon Jul 31 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.6.7-4m)
- import gcl-pers.patch from Fedora Core extras devel

* Sun Jul 23 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (2.6.7-3m)
- delete auto* command
- add patch1 (for bash-3.1)

* Fri Jul  7 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.6.7-2m)
- rebuild against readline-5.0

* Tue Nov  8 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (2.6.7-1m)
- update 2.6.7
- enable gcc4

* Tue Feb 15 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (2.6.6-2m)
- enable x86_64.

* Tue Feb 15 2005 Toru Hoshina <t@momonga-linux.org>
- (2.6.6-1m)
- update 2.6.6.

* Sun Oct 31 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (2.6.5-1m)
- update to 2.6.5
- install lsp/gcl_readline.lsp manually, otherwise gcl.sh fails at startup

* Mon Jun 28 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.5.3-7m)
- rebuild against tcl,tk

* Sat Mar 20 2004 Toru Hoshina <t@momonga-linux.org>
- (2.5.3-6m)
- revised spec for enabling rpm 4.2.

* Mon Dec 29 2003 Kenta MURATA <muraken2@nifty.com>
- (2.5.3-5m)
- use static system libbfd.

* Mon Dec 29 2003 Kenta MURATA <muraken2@nifty.com>
- (2.5.3-4m)
- Requires: gcc.

* Mon Dec 29 2003 Kenta MURATA <muraken2@nifty.com>
- (2.5.3-3m)
- some corrects.

* Mon Dec 29 2003 Kenta MURATA <muraken2@nifty.com>
- (2.5.3-2m)
- correct script.

* Mon Dec 29 2003 Kenta MURATA <muraken2@nifty.com>
- (2.5.3-1m)
- first spec file.
